import processing.serial.*; 

Serial lecteurcarte;    // variable "lecteur carte" de calsse Serial
PFont myFont;     // création d'une police de caractères "myFont"
String inString;  // création d'une cahine de caractères "inString"
int compteur=0;
String code_carte_hex="", code_carte_lue=""; 
int passage;
int n_cartes=20, longueur_code=22;

//configuration
void setup() { 
  // Taille de l'ecran 400x200 pixel
  size(400, 200); 
  //Police de caractères
  myFont = loadFont("ArialMT-18.vlw"); 
  textFont(myFont, 18);

  //configuration lecteurcarte comme port serie 0 (RS232) à 9600Bd. 
  lecteurcarte = new Serial(this, Serial.list()[0], 9600);
} 

//programme principal
void draw() {
  //test si une carte est lue
  if (code_carte_lue.length()>=longueur_code) {
    passage=0;
    // appel la fonction booleenne "validation_carte" et test si carte valide
    if (validation_carte(code_carte_lue)) {
      background(0, 255, 0);  //ecran vert 
      text("Carte valable", 10, 50);//imprime dans la fenêtre 400*200
      delay(3000);
    }
    //si carte non valide
    else {
      background(255, 0, 0); //ecran rouge  
      text("Carte invalide", 10, 50);//imprime dans la fenêtre 400*200
      delay(3000);
    }
  }
  //si pas de carte  
  else {
    if (passage==0) {
      background(0); //ecran noir  
      text("insérer une carte", 10, 50);//imprime dans la fenêtre 400*200
      print("insérer une carte") ;
      passage=1;
    }
  }
} 

// Fonction qui test la validitée de la carte
Boolean validation_carte(String carte_a_tester) {
  Boolean resultat_test=false;
  print("carte en cours de validation : ");//imprime sur l'écran ci dessous

  //charge la base de données dans la variable "liste_cartes"
  String[]  liste_cartes =loadStrings("Bd_cartes.txt");

  //test si la carte est bien dans la liste des cartes valides "liste_carte"
  for (int i=0;i<liste_cartes.length;i++) {
    if (carte_a_tester.equals(liste_cartes[i])) { 
      println("Carte valable");// imprime sur l'écran ci dessous      
      resultat_test=true;
      code_carte_lue="";
      return resultat_test;
    }
  }
  println("non valable");//imprime sur l'écran ci dessous
  resultat_test=false;
  code_carte_lue="";
  return resultat_test;
}

//interruption évènnement port série.
void serialEvent(Serial p) {  
  //convertie la valeur lue integer (p.read)  en hexadécimale (hex(p.read) et stock dans la variable "inString" 
  inString = hex( p.read());
  //stock dans "code_carte_hex" les deux derniers caractères de "inString"
  code_carte_hex =   code_carte_hex + inString.substring(6, 8);
  //met dans variable "code_carte_lue" les onze octets du code de la carte.
  compteur= compteur+1;
  if (compteur==longueur_code/2) { 
    code_carte_lue=code_carte_hex;
    p.clear();
    compteur=0;
    //imprime dans l'ecran ci dessous
    println(" ");
    print("code carte lu : "); 
    print(code_carte_lue); 
    println(".");
    //vide la variable "code_carte_hex"
    code_carte_hex="";
  }
} 

